﻿using System.Windows;
using System.Windows.Input;

namespace EditControlProblemDemo
{
    public partial class MainWindow : Window
    {
        private bool _isInsertTabChar = true;

        string orig = "text1 \t texT2 \t text3";//original text with a couple of \t char in it, single line for simplicity
        public MainWindow()
        {
            InitializeComponent();
        }

        private void contentsTextBox_Loaded(object sender, RoutedEventArgs e)
        {
            contentsTextBox.Text = orig;
        }

        private void contentsTextBox_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Tab)
            {
                if (_isInsertTabChar)
                {
                    e.Handled = true;
                }
            }
        }

        private void contentsTextBox_PreviewKeyUp(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Tab)
            {
                if (_isInsertTabChar)
                {
                    e.Handled = true;
                    InsertTab();
                }
            }
        }

        private void InsertTab()
        {
            contentsTextBox.TabSpaces = 0;
            int csr = GetCurrentCursorIndex();
            string txt = contentsTextBox.Text.Insert(csr, "\t");
            contentsTextBox.Text = txt;
            int l = contentsTextBox.LineNumber-1;
            int c = contentsTextBox.CursorIndex;
            contentsTextBox.SelectLines(l, l, c+1, c+1);//put cursor back
             
        }

        private int GetCurrentCursorIndex()
        {
            int idx = 0;
            int ln = contentsTextBox.LineNumber-1;
            for(int i=0; i<ln; i++)
            {
                idx += contentsTextBox.Lines[i].Text.Length + 2;//plus 2 for \r\n end line 
            }
            idx += contentsTextBox.CursorIndex;
            return idx;
        }

        private void radioInsertWhiteSpace_Checked(object sender, RoutedEventArgs e)
        {
            if (contentsTextBox != null)
            {
                bool isChecked = radioInsertWhiteSpace.IsChecked == true;
                if (isChecked)
                {
                    _isInsertTabChar = false;
                    contentsTextBox.TabSpaces = 4;
                }
            }
        }
        private void radioInsertTab_Checked(object sender, RoutedEventArgs e)
        {
            if (contentsTextBox != null)
            {
                bool isChecked = radioInsertTab.IsChecked == true;
                if (isChecked)
                {
                    _isInsertTabChar = true;
                    contentsTextBox.TabSpaces = 0;
                }
            }
        }

    }
}
